{{- $architecture := or .architecture "arm64" -}}
{{- $cdimagesmirror := or .cdimagesmirror "http://cdimage.ubuntu.com" -}}
{{- $additional_apt_repos := or .additional_apt_repos "" -}}
# Due to Go template's limitations in distinguish empty value from boolean,
# the default for this has to be false, hence the name.
{{- $skip_remove_apt_user := or .skip_remove_apt_user false }}

{{- $ubuntu_base := print "ubuntu-base-20.04.5-base-" $architecture ".tar.gz" }}

architecture: {{ $architecture }}
actions:
  - action: download
    description: Download Ubuntu Base, so that we don't have to run debootstrap
    url: "{{ $cdimagesmirror }}/ubuntu-base/releases/focal/release/{{ $ubuntu_base }}"
    unpack: false
    filename: {{ $ubuntu_base }}
    name: {{ $ubuntu_base }}

  - action: download
    description: Download SHA256SUMS from Ubuntu's CDImage server
    # Don't use mirror - do use HTTPS.
    url: https://cdimage.ubuntu.com/ubuntu-base/releases/focal/release/SHA256SUMS
    filename: SHA256SUMS
    name: SHA256SUMS

  - action: run
    description: Verify integrity of Ubuntu Base image.
    command: cd /scratch && sha256sum --check --ignore-missing SHA256SUMS
    label: sha256sum

  # Instead of an unpack action we use a run action here as a workaround to
  # https://github.com/go-debos/debos/issues/286 and
  # https://gitlab.com/ubports/community-ports/android10/project-management/-/issues/9
  - action: run
    description: Unpacking rootfs
    command: tar --numeric-owner -xzf {{ $ubuntu_base }} -C root

  - action: download
    description: Download UBports keyring
    url: https://repo.ubports.com/keyring.gpg
    name: keyring

  - action: overlay
    description: Add UBports keyring to the rootfs
    origin: keyring
    destination: /etc/apt/trusted.gpg.d/ubports.gpg

  - action: run
    description: Add UBports focal repo (and any additional repos)
    # Note, this operation also updates packages in base image.
    chroot: true
    script: >-
      ../scripts/add-and-pin-repo.sh
      http://repo.ubports.com/ focal 2000
      {{ $additional_apt_repos }}
    label: add-and-pin-repo.sh

